Package org.apache.commons.math3.linear

# Class DefaultIterativeLinearSolverEvent

java.lang.Object
java.util.EventObject
org.apache.commons.math3.util.IterationEvent
org.apache.commons.math3.linear.IterativeLinearSolverEvent
org.apache.commons.math3.linear.DefaultIterativeLinearSolverEvent

All Implemented Interfaces:
  `Serializable`

public class DefaultIterativeLinearSolverEvent extends IterativeLinearSolverEvent
A default concrete implementation of the abstract class `IterativeLinearSolverEvent`.

See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class java.util.EventObject

`source`

## Constructor Summary

Constructors
Constructor
Description
`DefaultIterativeLinearSolverEvent(Object source, int iterations, RealVector x, RealVector b, double rnorm)`
Creates a new instance of this class.
`DefaultIterativeLinearSolverEvent(Object source, int iterations, RealVector x, RealVector b, RealVector r, double rnorm)`
Creates a new instance of this class.

## Method Summary

Modifier and Type
Method
Description
`double`
`getNormOfResidual()`
Returns the norm of the residual.
`RealVector`
`getResidual()`
Returns the residual.
`RealVector`
`getRightHandSideVector()`
Returns the current right-hand side of the linear system to be solved.
`RealVector`
`getSolution()`
Returns the current estimate of the solution to the linear system to be solved.
`boolean`
`providesResidual()`
Returns `true` if `IterativeLinearSolverEvent.getResidual()` is supported.

### Methods inherited from class org.apache.commons.math3.util.IterationEvent

`getIterations`

### Methods inherited from class java.util.EventObject

`getSource, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### DefaultIterativeLinearSolverEvent

public DefaultIterativeLinearSolverEvent(Object source, int iterations, RealVector x, RealVector b, RealVector r, double rnorm)
Creates a new instance of this class. This implementation does not deep copy the specified vectors `x`, `b`, `r`. Therefore the user must make sure that these vectors are either unmodifiable views or deep copies of the same vectors actually used by the `source`. Failure to do so may compromise subsequent iterations of the `source`. If the residual vector `r` is `null`, then `getResidual()` throws a `MathUnsupportedOperationException`, and `providesResidual()` returns `false`.

Parameters:
  `source` - the iterative solver which fired this event
  `iterations` - the number of iterations performed at the time `this` event is created
  `x` - the current estimate of the solution
  `b` - the right-hand side vector
  `r` - the current estimate of the residual (can be `null`)
  `rnorm` - the norm of the current estimate of the residual

### DefaultIterativeLinearSolverEvent

public DefaultIterativeLinearSolverEvent(Object source, int iterations, RealVector x, RealVector b, double rnorm)
Creates a new instance of this class. This implementation does not deep copy the specified vectors `x`, `b`. Therefore the user must make sure that these vectors are either unmodifiable views or deep copies of the same vectors actually used by the `source`. Failure to do so may compromise subsequent iterations of the `source`. Callling `getResidual()` on instances returned by this constructor throws a `MathUnsupportedOperationException`, while `providesResidual()` returns `false`.

Parameters:
  `source` - the iterative solver which fired this event
  `iterations` - the number of iterations performed at the time `this` event is created
  `x` - the current estimate of the solution
  `b` - the right-hand side vector
  `rnorm` - the norm of the current estimate of the residual

## Method Details

### getNormOfResidual

public double getNormOfResidual()
Returns the norm of the residual. The returned value is not required to be exact. Instead, the norm of the so-called updated residual (if available) should be returned. For example, the `conjugate gradient` method computes a sequence of residuals, the norm of which is cheap to compute. However, due to accumulation of round-off errors, this residual might differ from the true residual after some iterations. See e.g. A. Greenbaum and Z. Strakos, Predicting the Behavior of Finite Precision Lanzos and Conjugate Gradient Computations, Technical Report 538, Department of Computer Science, New York University, 1991 (available here).

Specified by:
  `getNormOfResidual` in class `IterativeLinearSolverEvent`
Returns:
  the norm of the residual, ||r||

### getResidual

public RealVector getResidual()

Returns the residual. This is an optional operation, as all iterative linear solvers do not provide cheap estimate of the updated residual vector, in which case

- this method should throw a `MathUnsupportedOperationException`,
- `IterativeLinearSolverEvent.providesResidual()` returns `false`.

The default implementation throws a `MathUnsupportedOperationException`. If this method is overriden, then `IterativeLinearSolverEvent.providesResidual()` should be overriden as well.

This implementation throws an `MathUnsupportedOperationException` if no residual vector `r` was provided at construction time.

Overrides:
  `getResidual` in class `IterativeLinearSolverEvent`
Returns:
  the updated residual, r

### getRightHandSideVector

public RealVector getRightHandSideVector()
Returns the current right-hand side of the linear system to be solved. This method should return an unmodifiable view, or a deep copy of the actual right-hand side vector, in order not to compromise subsequent iterations of the source `IterativeLinearSolver`.

Specified by:
  `getRightHandSideVector` in class `IterativeLinearSolverEvent`
Returns:
  the right-hand side vector, b

### getSolution

public RealVector getSolution()
Returns the current estimate of the solution to the linear system to be solved. This method should return an unmodifiable view, or a deep copy of the actual current solution, in order not to compromise subsequent iterations of the source `IterativeLinearSolver`.

Specified by:
  `getSolution` in class `IterativeLinearSolverEvent`
Returns:
  the solution, x

### providesResidual

public boolean providesResidual()
Returns `true` if `IterativeLinearSolverEvent.getResidual()` is supported. The default implementation returns `false`. This implementation returns `true` if a non-`null` value was specified for the residual vector `r` at construction time.

Overrides:
  `providesResidual` in class `IterativeLinearSolverEvent`
Returns:
  `true` if `r != null`